/*-
 * Copyright (c) 2006 Stanislav Sedov <stas@FreeBSD.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $MBSDlabs: devcpu/cpu/msrsupp_amd64.S,v 1.5 2006/12/08 22:32:35 stas Exp $
 *
 */
#include <sys/errno.h>
#include <machine/asmacros.h>
	.text
ENTRY(cpu_rdmsr)
/* cpu_rdmsr(int msr, uint64_t *data)
                 %edi,          %rsi
*/
	MEXITCOUNT
	movl	%edi, %ecx
	rdmsr			/* Read MSR pointed by %ecx */
				/* Will return hi byte in edx, lo in %eax */
	salq	$32, %rdx	/* Sign-shift %rdx left */
	cltq			/* Sign-extend %eax -> %rax */
	orq	%rdx, %rax
	movq	%rax, (%rsi)
	xorl	%eax, %eax
	ret

ENTRY(cpu_wrmsr)
/* cpu_wrmsr(int msr, uint64_t data)
                 %edi,          %rsi
*/
	MEXITCOUNT
	movl	%edi, %ecx
	movl	%esi, %eax
	sarq	$32, %rsi
	movl	%esi, %edx
	wrmsr			/* Write MSR pointed by %ecx */
				/* Will accept hi byte in edx, lo in %eax */
	xorl	%eax, %eax
	ret

	ALIGN_TEXT
	.globl msr_onfault
msr_onfault:
	movl $EFAULT, %eax
	ret
